#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>

#define vi vector<int>
#define vll vector<long long>
#define vc vector<char>
#define vcc vector<vector<char> >
#define vvi vector<vector<int> >

typedef long long ll;

using namespace std;

vcc v;

int r1, r2, c1, c2;
int n, m;
bool flag;

void print(vvi v) {
	for (int i = 0; i < v.size(); i++) {
		for (int j = 0; j < v[i].size(); j++) {
			cout << v[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
}

int calc_dist(int a, int b, int c, int d) {
	return  abs(a - c) + abs(b - d);
}

void fill_tables(vvi &v, int i, int a, int b, int c, int d) {
	v[i][0] = a;
	v[i][1] = b;
	v[i][2] = c;
	v[i][3] = d;
}

bool comp(const vi &v1, const vi &v2) {
	return calc_dist(v1[0], v1[1], v1[2], v1[3]) < calc_dist(v2[0], v2[1], v2[2], v2[3]);
}

void find(int x, int y) {
	vvi answ_table(4, vi(4, -1));

	if (x < n - 1 && y < m - 1) {
		int i = x + 1, j = y + 1;
		if (v[i][y] != v[x][j]) {
			fill_tables(answ_table, 0, i, y, x, j);
		}
		else {
			while (i < n && v[i][y] == v[x][y + 1]) i++;
			while (j < m && v[x][j] == v[x + 1][y]) j++;
			if (i != n || j != m) {
				if (i != n && j != m) {
					if (calc_dist(i, y, x, y + 1) < calc_dist(x + 1, y, x, j)) {
						fill_tables(answ_table, 0, i, y, x, y + 1);
					}
					else {
						fill_tables(answ_table, 0, x + 1, y, x, j);
					}
				}
				else {
					if (i != n) {
						fill_tables(answ_table, 0, i, y, x, y + 1);
					}
					else {
						fill_tables(answ_table, 0, x + 1, y, x, j);
					}
				}
			}
		}
	}

	if (x > 0 && y < m - 1) {
		int i = x - 1, j = y + 1;
		if (v[i][y] != v[x][j]) {
			fill_tables(answ_table, 1, i, y, x, j);
		}
		else {
			while (i >= 0 && v[i][y] == v[x][y + 1]) i--;
			while (j < m && v[x][j] == v[x - 1][y]) j++;
			if (i != -1 || j != m) {
				if (i != -1 && j != m) {
					if (calc_dist(i, y, x, y + 1) < calc_dist(x - 1, y, x, j)) {
						fill_tables(answ_table, 1, i, y, x, y + 1);
					}
					else {
						fill_tables(answ_table, 1, x - 1, y, x, j);
					}
				}
				else {
					if (i != -1) {
						fill_tables(answ_table, 1, i, y, x, y + 1);
					}
					else {
						fill_tables(answ_table, 1, x - 1, y, x, j);
					}
				}
			}
		}
	}

	if (x > 0 && y > 0) {
		int i = x - 1, j = y - 1;
		if (v[i][y] != v[x][j]) {
			fill_tables(answ_table, 2, i, y, x, j);
		}
		else {
			while (i >= 0 && v[i][y] == v[x][y - 1]) i--;
			while (j >= 0 && v[x][j] == v[x - 1][y]) j--;
			if (i != -1 || j != -1) {
				if (i != -1 && j != -1) {
					if (calc_dist(i, y, x, y - 1) < calc_dist(x - 1, y, x, j)) {
						fill_tables(answ_table, 2, i, y, x, y - 1);
					}
					else {
						fill_tables(answ_table, 2, x - 1, y, x, j);
					}
				}
				else {
					if (i != -1) {
						fill_tables(answ_table, 2, i, y, x, y - 1);
					}
					else {
						fill_tables(answ_table, 2, x - 1, y, x, j);
					}
				}
			}
		}
	}

	if (x < n - 1 && y > 0) {
		int i = x + 1, j = y - 1;
		if (v[i][y] != v[x][j]) {
			fill_tables(answ_table, 3, i, y, x, j);
		}
		else {
			while (i < n && v[i][y] == v[x][y - 1]) i++;
			while (j >= 0 && v[x][j] == v[x + 1][y]) j--;
			if (i != n || j != -1) {
				if (i != n && j != -1) {
					if (calc_dist(i, y, x, y + 1) < calc_dist(x + 1, y, x, j)) {
						fill_tables(answ_table, 3, i, y, x, y - 1);
					}
					else {
						fill_tables(answ_table, 3, x + 1, y, x, j);
					}
				}
				else {
					if (i != n) {
						fill_tables(answ_table, 3, i, y, x, y - 1);
					}
					else {
						fill_tables(answ_table, 3, x + 1, y, x, j);
					}
				}
			}
		}
	}

	//print(answ_table);

	sort(answ_table.begin(), answ_table.end(), comp);
	int i = 0;
	while (i < 4 && answ_table[i][0] == -1) i++;
	if (i == 4)
		flag = false;
	else {
		r1 = answ_table[i][0];
		c1 = answ_table[i][1];
		r2 = answ_table[i][2];
		c2 = answ_table[i][3];
	}
}

int main() {
	cin >> n >> m;
	string tmp;
	v.resize(n, vc(m));

	for (int i = 0; i < n; i++) {
		cin >> tmp;
		for (int j = 0; j < m; j++) {
			v[i][j] = tmp[j];
		}
	}
	int q, x, y;
	cin >> q;
	for (int i = 0; i < q; i++) {
		scanf("%d%d", &x, &y);
		x--;
		y--;
		flag = true;
		find(x, y);
		if (!flag)
			printf("-1\n");
		else
			printf("%d %d %d %d\n", r1 + 1, c1 + 1, r2 + 1, c2 + 1);

	}
	//system("pause");
	return 0;
}