#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;

const int MOD = 1e9 + 7;
vector <ll> pow17, pow19;

ll pw17(ll p) {
    return pow17[p];
}

ll pw19(ll p) {
    return pow19[p];
}


int main() {
    int h, w, n;
    cin >> h >> w >> n;

    pow17.resize(h, 1);
    pow19.resize(w, 1);

    for (int i = 1; i < h; ++i)
        pow17[i] = pow17[i - 1] * 17 % MOD;


    for (int i = 1; i < w; ++i)
        pow19[i] = pow19[i - 1] * 19 % MOD;


    string s;
    cin >> s;
    vector <int> A, B, C, D;
    vector <int> ax(n), bx(n), cx(n), dx(n);
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> ax[i];
    for (int i = k; i < n; ++i) {
        ax[i] = (10007 * ax[i - 2] + 10009 * ax[i - 1] + 87277) % h;
    }

    cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> bx[i];
    for (int i = k; i < n; ++i) {
        bx[i] = (10007 * bx[i - 2] + 10009 * bx[i - 1] + 87277) % w;
    }

    cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> cx[i];
    for (int i = k; i < n; ++i) {
        cx[i] = (10007 * cx[i - 2] + 10009 * cx[i - 1] + 87277) % h;
    }

    cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> dx[i];
    for (int i = k; i < n; ++i) {
        dx[i] = (10007 * dx[i - 2] + 10009 * dx[i - 1] + 87277) % w;
    }


    vector <vector <int> > g(h, vector <int> (w, 0));
    for (int i = 0; i < h; ++i)
        for (int j = 0; j < w; ++j)
            g[i][j] = i * w + j;

    vector <int> whoc(w), wherec(w);
    vector <int> whor(h), wherer(h);
    for (int i = 0; i < w; ++i) {
        whoc[i] = i;
        wherec[i] = i;
    }
    for (int i = 0; i < h; ++i) {
        whor[i] = i;
        wherer[i] = i;
    }

    for (int i = 0; i < n; ++i) {
        if (s[i] == 'f') {
            swap(g[wherer[ax[i]]][wherec[bx[i]]], g[wherer[cx[i]]][wherec[dx[i]]]);
        } else if (s[i] == 'c') {
            int ff = wherec[bx[i]], ss = wherec[dx[i]];
            swap(whoc[ff], whoc[ss]);
            wherec[whoc[ss]] = ss;
            wherec[whoc[ff]] = ff;
        } else {
            int ff = wherer[ax[i]], ss = wherer[cx[i]];
            swap(whor[ff], whor[ss]);
            wherer[whor[ss]] = ss;
            wherer[whor[ff]] = ff;
        }
    }

    ll ans = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            ans = (ans + (((g[i][j] * pw17(whor[i])) % MOD) * pw19(whoc[j])) % MOD) % MOD;
        }
    }
    cout << ans << "\n";
    return 0;
}
