#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

const int N = (int) 4e5 + 123;

int n, k, m;

int run() {
	cin >> n >> k >> m;
	vector<int> q;
	vector<int> X;
	vector<int> dp;

	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		q.push_back(x);
		X.push_back(x);
		X.push_back(x + k - 1);
	}

	sort(q.begin(), q.end());
	sort(X.begin(), X.end());
	X.resize(unique(X.begin(), X.end()) - X.begin());
	dp.resize(X.size());

	for (int i = 0; i < (int)X.size(); i++) {
		int right = X[i];
		int left = right - k + 1;
		int j = lower_bound(q.begin(), q.end(), left) - q.begin() - 1;
		if (j < 0) {
			dp[i] = max(0, left - 1);
		}
		else {
			int it = lower_bound(X.begin(), X.end(), q[j]) - X.begin();
			int dist = max(0, min(left, n + 1) - X[it] - 1);
			dp[i] = dp[it] + dist;
		}
	}

	int ans = 0;
	for (int i = 0; i < (int)X.size(); i++) {
		if (X[i] >= *q.rbegin()) {
			ans = max(ans, dp[i] + max(0, n - X[i]));
		}
	}

	cout << ans << "\n";
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}