#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

const int N = 302;

#define base bitset<N>

int n, k;
base know[N];
base dp[N][N];

int run() {
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		int cnt;
		cin >> cnt;
		for (int j = 0; j < cnt; j++) {
			int id;
			cin >> id;
			id--;
			know[id][i] = 1;
		}
	}

	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			for (int k = 0; k < N; k++) {
				if (i != j) dp[i][j][k] = 1;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int c = 0; c < k; c++) {
				if (know[c][i] && know[c][j]) {
					if (dp[i][j].count() >= know[c].count()) {
						dp[i][j] = know[c];
					}
				}
			}
		}
	}

	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				auto t = (dp[i][k] | dp[k][j]);
				if (t.count() <= dp[i][j].count()) {
					dp[i][j] = t;
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (dp[i][j][N - 1]) {
				cout << "-1 ";
			}
			else {
				cout << dp[i][j].count() << " ";
			}
		}
		cout << "\n";
	}

	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}