#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e8;
const int MAXSIZE = 500010;
const int maxN = 2e5 + 1000;

int d[maxN];
int dp[maxN];

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));
		
	int n, k, m;
	scanf("%d%d%d", &n, &k, &m);

	for (int i = 0; i < m; i++)
	{
		scanf("%d", &d[i]);
	}

	sort(d, d + m);

	for (int i = 0; i < m; i++)
	{
		int x = d[i] - k;
		if (x <= 0)
		{
			dp[i] = 0;
		}
		else
		{
			int l = -1, r = m;
			while (r - l > 1)
			{
				int mid = (l + r) / 2;
				if (d[mid] <= x)
				{
					l = mid;
				}
				else
				{
					r = mid;
				}
			}
			if (l == -1)
			{
				dp[i] = d[i] - k;
			}
			else
			{
				dp[i] = d[i] - d[l] - k + dp[l];
			}
		}
	}

	int res = dp[m - 1] + n - d[m - 1];

	for (int i = m - 1; i > 0; i--)
	{
		int x = d[i] + k;
		if (x > n)
		{
			res = max(res, d[i] - d[i - 1] - 1 + dp[i - 1]);
		}
		else
		{
			int l = -1, r = m;
			while (r - l > 1)
			{
				int mid = (r + l) / 2;
				if (d[mid] >= x)
				{
					r = mid;
				}
				else
				{
					l = mid;
				}
			}
			if (r == m)
			{
				res = max(res, d[i] - d[i - 1] - 1 + dp[i - 1]);
			}
		}
	}

	int l = -1, r = m;
	while (r - l > 1)
	{
		int mid = (r + l) / 2;
		if (d[mid] >= d[0] + k)
		{
			r = mid;
		}
		else
		{
			l = mid;
		}
	}
	if (r == m)
	{
		res = max(res, d[0] - 1);
	}

	cout << res;



	
	return 0;
}