#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e8;
const int MAXSIZE = 500010;

inline int id(char c) {
	return (c - 'a');
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	char buf[MAXSIZE];
	int n, m;
	scanf("%d%d", &n, &m);

	vector<vector<char> > s(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		scanf("%s", &buf);
		for (int j = 0; j < m; j++) {
			s[i][j] = buf[j];
		}
	}

	//precalc
	vector<vector<vector<int> > > rsuf(n, vector<vector<int> >(m, vector<int>(26, INF))), 
		csuf(n, vector<vector<int> >(m, vector<int>(26, INF))), 
		rpref(n, vector<vector<int> >(m, vector<int>(26, -INF))), 
		cpref(n, vector<vector<int> >(m, vector<int>(26, -INF)));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int c = 0; c < 26; c++) {
				if (i > 0) cpref[i][j][c] = cpref[i - 1][j][c];
				if (j > 0) rpref[i][j][c] = rpref[i][j - 1][c];
			}

			int c = id(s[i][j]);
			cpref[i][j][c] = i;
			rpref[i][j][c] = j;
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			for (int c = 0; c < 26; c++) {
				if (i < n - 1) csuf[i][j][c] = csuf[i + 1][j][c];
				if (j < m - 1) rsuf[i][j][c] = rsuf[i][j + 1][c];
			}

			int c = id(s[i][j]);
			csuf[i][j][c] = i;
			rsuf[i][j][c] = j;
		}
	}

	//===
	
	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;
		
		int mnr, mnc, mnd = INF;
		for (int r = 0; r < 26; r++) {
			for (int c = 0; c < 26; c++) {
				if (r == c) continue;

				int rs = INF, rp = -INF, cs = INF, cp = -INF;

				if (y > 0)
					rp = rpref[x][y - 1][r];
				if (y < m - 1)
					rs = rsuf[x][y + 1][r];
				if (x > 0)
					cp = cpref[x - 1][y][c];
				if (x < n - 1)
					cs = csuf[x + 1][y][c];

				int d = min(x - cp, cs - x) + min(y - rp, rs - y);
				if (d > 1e7) {
					continue;
				}
				if (d < mnd) {
					mnd = d;
					
					if (x - cp < cs - x) {
						mnc = cp;
					}
					else {
						mnc = cs;
					}

					if (y - rp < rs - y) {
						mnr = rp;
					}
					else {
						mnr = rs;
					}
				}
			}
		}

		if (mnd == INF) {
			printf("-1\n");
		}
		else {
			printf("%d %d %d %d\n", x + 1, mnr + 1, mnc + 1, y + 1);
		}
	}

	return 0;
}