#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e8;
const int MAXSIZE = 500010;

inline int id(char c) {
	return (c - 'a');
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	char buf[MAXSIZE];
	int n, m;
	scanf("%d%d", &n, &m);

	vector<vector<char> > s(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		scanf("%s", &buf);
		for (int j = 0; j < m; j++) {
			s[i][j] = buf[j];
		}
	}

	//precalc
	vector<vector<vector<int> > > rsuf(n, vector<vector<int> >(m, vector<int>(26, INF))), 
		csuf(n, vector<vector<int> >(m, vector<int>(26, INF))), 
		rpref(n, vector<vector<int> >(m, vector<int>(26, -INF))), 
		cpref(n, vector<vector<int> >(m, vector<int>(26, -INF)));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int c = 0; c < 26; c++) {
				if (i > 0) {
					cpref[i][j][c] = cpref[i - 1][j][c];
					if (id(s[i - 1][j]) == c)
						cpref[i][j][c] = i - 1;
				}
				if (j > 0) {
					rpref[i][j][c] = rpref[i][j - 1][c];
					if (id(s[i][j - 1]) == c)
						rpref[i][j][c] = j - 1;
				}
			}
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			for (int c = 0; c < 26; c++) {
				if (i < n - 1) {
					csuf[i][j][c] = csuf[i + 1][j][c];
					if (id(s[i + 1][j]) == c)
						csuf[i][j][c] = i + 1;
				}
				if (j < m - 1) {
					rsuf[i][j][c] = rsuf[i][j + 1][c];
					if (id(s[i][j + 1]) == c)
						rsuf[i][j][c] = j + 1;
				}
			}
		}
	}

	vector<pii> ch;
	vector<vector<vector<pii> > > h(n, vector<vector<pii> >(m, vector<pii>(2))), 
		v(n, vector<vector<pii> >(m, vector<pii>(2)));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ch.clear();
			for (int c = 0; c < 26; c++) {
				if (abs(cpref[i][j][c] - i) < abs(csuf[i][j][c] - i))
					ch.push_back(make_pair(cpref[i][j][c] - i, c));
				else 
					ch.push_back(make_pair(csuf[i][j][c] - i, c));
			}
			sort(ch.begin(), ch.end(), [](pii a, pii b){
				return abs(a.first) < abs(b.first);
			});
			v[i][j][0] = ch[0], v[i][j][1] = ch[1];

			ch.clear();
			for (int c = 0; c < 26; c++) {
				if (abs(rpref[i][j][c] - j) < abs(rsuf[i][j][c] - j))
					ch.push_back(make_pair(rpref[i][j][c] - j, c));
				else
					ch.push_back(make_pair(rsuf[i][j][c] - j, c));
			}
			sort(ch.begin(), ch.end(), [](pii a, pii b){
				return abs(a.first) < abs(b.first);
			});
			h[i][j][0] = ch[0], h[i][j][1] = ch[1];
		}
	}

	//===
	
	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;
		
		int mind = INF, minr, minc;
		for (int j = 0; j < 2; j++) {
			for (int k = 0; k < 2; k++) {
				if (h[x][y][j].second != v[x][y][k].second) {
					int dist = abs(h[x][y][j].first) + abs(v[x][y][k].first);
					if (dist < mind) {
						mind = dist;
						minr = y + h[x][y][j].first;
						minc = x + v[x][y][k].first;
					}
				}
			}
		}

		if (mind > n + m) {
			printf("-1\n");
		}
		else {
			printf("%d %d %d %d\n", x + 1, minr + 1, minc + 1, y + 1);
		}
	}

	return 0;
}