#include <iostream>
#include <vector>

using namespace std;

struct point
{
    int x, y;
};

int n, m, q;
vector <vector <char> > v;
vector <vector <int> > up, rright, down, lleft;
vector <vector <point> > pup, pright, pdown, pleft;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> m;
    v.resize(n, vector <char>(m));
    up.resize(n, vector <int>(m, 1e9));
    pup.resize(n, vector <point>(m));
    rright.resize(n, vector <int>(m, 1e9));
    pright.resize(n, vector <point>(m));
    down.resize(n, vector <int>(m, 1e9));
    pdown.resize(n, vector <point>(m));
    lleft.resize(n, vector <int>(m, 1e9));
    pleft.resize(n, vector <point>(m));

    for (int i = 0; i < n; i++)
        for (int y = 0; y < m; y++)
            cin >> v[i][y];

    for (int i = 0; i < n; i++)
    {
        for (int y = 0; y < m; y++)
        {
            if (i > 0)
            {
                if (v[i][y] != v[i - 1][y])
                    up[i][y] = 1, pup[i][y] = {i, y + 1};
                else
                    up[i][y] = up[i - 1][y] + 1, pup[i][y] = pup[i - 1][y];
            }
            if (y > 0)
            {
                if (v[i][y] != v[i][y - 1])
                    lleft[i][y] = 1, pleft[i][y] = {i + 1, y};
                else
                    lleft[i][y] = lleft[i][y - 1] + 1, pleft[i][y] = pleft[i][y - 1];
            }
        }
    }

    for (int i = n - 1; i >= 0; i--)
    {
        for (int y = m - 1; y >= 0; y--)
        {
            if (i < n - 1)
            {
                if (v[i][y] != v[i + 1][y])
                    down[i][y] = 1, pdown[i][y] = {i + 2, y + 1};
                else
                    down[i][y] = down[i + 1][y] + 1, pdown[i][y] = pdown[i][y + 1];
            }
            if (y < m - 1)
            {
                if (v[i][y] != v[i][y + 1])
                    rright[i][y] = 1, pright[i][y] = {i + 1, y + 2};
                else
                    rright[i][y] = rright[i][y + 1] + 1, pright[i][y] = pright[i][y + 1];
            }
        }
    }

    cin >> q;
    while (q--)
    {
        int x, y, ans = 2e9 + 123;
        point p1, p2;
        cin >> x >> y;
        x--, y--;

        if (x > 0 && y > 0)
        {
            if (v[x - 1][y] != v[x][y - 1])
            {
                cout << x << " " << y + 1 << " " << x + 1 << " " << y << endl;
                continue;
            }
            if (up[x - 1][y] + 2 < ans && up[x - 1][y] < 1e9)
            {
                ans = up[x - 1][y] + 2;
                p1 = pup[x - 1][y];
                p2 = {x + 1, y};

            }
            if (lleft[x][y - 1] + 2 < ans && lleft[x][y - 1] < 1e9)
            {
                ans = lleft[x][y - 1] + 2;
                p1 = {x, y + 1};
                p2 = pleft[x][y - 1];
            }
        }
        if (x > 0 && y < m - 1)
        {
            if (v[x - 1][y] != v[x][y + 1])
            {
                cout << x << " " << y + 1 << " " << x + 1 << " " << y + 2 << endl;
                continue;
            }
            if (up[x - 1][y] + 2 < ans && up[x - 1][y] < 1e9)
            {
                ans = up[x - 1][y] + 2;
                p1 = pup[x - 1][y];
                p2 = {x + 1, y + 2};

            }
            if (rright[x][y + 1] + 2 < ans && rright[x][y + 1] < 1e9)
            {
                ans = rright[x][y + 1] + 2;
                p1 = {x, y + 1};
                p2 = pright[x][y + 1];
            }
        }
        if (x < n - 1 && y > 0)
        {
            if (v[x + 1][y] != v[x][y - 1])
            {
                cout << x + 2 << " " << y + 1 << " " << x + 1 << " " << y << endl;
                continue;
            }
            if (down[x + 1][y] + 2 < ans && down[x + 1][y] < 1e9)
            {
                ans = down[x + 1][y] + 2;
                p1 = pdown[x + 1][y];
                p2 = {x + 1, y};
            }
            if (lleft[x][y - 1] + 2 < ans && lleft[x][y - 1] < 1e9)
            {
                ans = lleft[x][y - 1] + 2;
                p1 = {x + 2, y + 1};
                p2 = pleft[x][y - 1];
            }
        }
        if (x < n - 1 && y < m - 1)
        {
            if (v[x + 1][y] != v[x][y + 1])
            {
                cout << x + 2 << " " << y + 1 << " " << x + 1 << " " << y + 2 << endl;
                continue;
            }
            if (down[x + 1][y] + 2 < ans && down[x + 1][y] < 1e9)
            {
                ans = down[x + 1][y] + 2;
                p1 = pdown[x + 1][y];
                p2 = {x + 1, y + 2};
            }
            if (rright[x][y + 1] + 2 < ans && rright[x][y + 1] < 1e9)
            {
                ans = rright[x][y + 1] + 2;
                p1 = {x + 2, y + 1};
                p2 = pright[x][y + 1];
            }
        }

        if (ans != 2e9 + 123)
        {
            cout << p1.x << " " << p1.y << " " << p2.x << " " << p2.y << endl;
        }
        else
            cout << -1 << endl;
    }
    return 0;
}

/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
*/
