#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t

struct hap {
    int time, type, id;
    hap(int time, int type, int id) {
        this -> time = time;
        this -> type = type;
        this -> id = id;
    }
};

bool cmp(hap a, hap b) {
    if (a.time != b.time)
        return a.time < b.time;
    else if (a.type != b.type)
        return a.type < b.type;
    else
        return a.id < b.id;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<hap> haps;
    vector<pair<int, int> > segments(k);
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        segments[i] = {a, b};
        haps.push_back(hap(a, 1, i));
        haps.push_back(hap(b, -1, i));
    }

    sort(haps.begin(), haps.end(), cmp);


    set<int> empty_sits, empty_stands;
    for (int i = 0; i < m; i++)
        empty_stands.insert(i);
    for (int i = 0; i < m - 1; i++)
        empty_sits.insert(i);

    vector<pair<int, bool> > place(k, {-1, false}); //first is place, second is IS_SITTING

    vector<int> cnt(m);

    for (auto hap : haps) {
        //cout << hap.time << " " << hap.type << " " << hap.id << endl;
        if (hap.type == 1) {
            if (!empty_sits.empty()) {
                int cur = *empty_sits.begin();
                empty_sits.erase(empty_sits.begin());
                place[hap.id] = {cur, true};
            }
            else if (!empty_stands.empty()) {
                int cur = *empty_stands.begin();
                empty_stands.erase(empty_stands.begin());
                cnt[cur] += segments[hap.id].second - segments[hap.id].first;
                place[hap.id] = {cur, false};
            }
        }
        else if (place[hap.id].first != -1) {
            if (place[hap.id].second) //if sit
                empty_sits.insert(place[hap.id].first);
            else
                empty_stands.insert(place[hap.id].first);
        }
    }

    int min_ans = cnt[0], ans_pos = 0;
    for (int i = 0; i < cnt.size(); i++) {
        if (cnt[i] < min_ans) {
            min_ans = cnt[i];
            ans_pos = i;
        }
    }

    cout << min_ans << " " << ans_pos + 1 << endl;

    return 0;
}
