#include <iostream>
#include <vector>
#include <algorithm>

#define mp(a, b) make_pair(a, b)

using namespace std;

const int INF = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector <vector <char> > data(max(n, m), vector <char> (min(n, m), 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (n < m) {
                cin >> data[j][i];
            } else {
                cin >> data[i][j];
            }
        }
    }
    bool fl = 0;
    if (n < m) {
        swap(n, m);
        fl = 1;
    }
    vector <int> let[n][31], not_let[m][31];
    //vector <vector <vector <int> > > let(n, vector <vector <int> > (31));
    //vector <vector <vector <int> > > not_let(m, vector <vector <int> > (31));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x = data[i][j];
            int k = x - 'a';
            let[i][k].push_back(j);
            for (int l = 0; l < 26; l++) {
                if (l == k) continue;
                not_let[j][l].push_back(i);
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (fl) swap(x, y);
        int min_rast = INF;
        pair <int, int> c1, c2;
        for (int j = 0; j < 26; j++) {
            if (let[x][j].empty() || not_let[y][j].empty()) continue;
            int l = -1, r = let[x][j].size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (let[x][j][mid] < y) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            int l1 = -1, r1 = -1;
            if (l != -1) {
                l1 = let[x][j][l];
            }
            if (l + 1 < let[x][j].size() && let[x][j][l + 1] != y) {
                r1 = let[x][j][l + 1];
            } else if (l + 2 < let[x][j].size()) {
                r1 = let[x][j][l + 2];
            }
            l = -1;
            r = not_let[y][j].size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (not_let[y][j][mid] < x) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            int l2 = -1, r2 = -1;
            if (l != -1) {
                l2 = not_let[y][j][l];
            }
            if (l + 1 < not_let[y][j].size() && not_let[y][j][l + 1] != x) {
                r2 = not_let[y][j][l + 1];
            } else if (l + 2 < not_let[y][j].size()) {
                r2 = not_let[y][j][l + 2];
            }
            if (l1 == -1 && l2 == -1 && r2 == -1 && r1 == -1) continue;
            if (l1 != -1) {
                if (l2 != -1) {
                    if (min_rast > abs(l1 - y) + abs(l2 - x)) {
                        min_rast = abs(l1 - y) + abs(l2 - x);
                        c1 = mp(x, l1);
                        c2 = mp(l2, y);
                    }
                }
                if (r2 != -1) {
                    //min_rast = min(min_rast, abs(l1 - y) + abs(r2 - x));
                    if (min_rast > abs(l1 - y) + abs(r2 - x)) {
                        min_rast = abs(l1 - y) + abs(r2 - x);
                        c1 = mp(x, l1);
                        c2 = mp(r2, y);
                    }
                }
            }
            if (r1 != -1) {
                if (l2 != -1) {
                    if (min_rast > abs(r1 - y) + abs(l2 - x)) {
                        min_rast = abs(r1 - y) + abs(l2 - x);
                        c1 = mp(x, r1);
                        c2 = mp(l2, y);
                    }
                }
                if (r2 != -1) {
                    if (min_rast > abs(r1 - y) + abs(r2 - x)) {
                        min_rast = abs(r1 - y) + abs(r2 - x);
                        c1 = mp(x, r1);
                        c2 = mp(r2, y);
                    }
                }
            }
        }
        if (min_rast == INF) {
            cout << -1 << '\n';
        } else {
            if (fl) {
                cout << c1.second + 1 << " " << c1.first + 1 << " " << c2.second + 1 << " " << c2.first + 1 << '\n';
            } else {
                cout << c1.first + 1 << " " << c1.second + 1 << " " << c2.first + 1 << " " << c2.second + 1 << '\n';
            }
        }
    }
    return 0;
}
/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
*/
