#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

inline int readChar();
template <class T = int> inline T readInt();
template <class T> inline void writeInt(T x, char end = 0);
inline void writeChar(int x);

static const int buf_size = 4096;

inline int getChar() {
	static char buf[buf_size];
	static int len = 0, pos = 0;
	if (pos == len)
		pos = 0, len = fread(buf, 1, buf_size, stdin);
	if (pos == len)
		return -1;
	return buf[pos++];
}

inline int readChar() {
	int c = getChar();
	while (c <= 32)
		c = getChar();
	return c;
}

template <class T>
inline T readInt() {
	int s = 1, c = readChar();
	T x = 0;
	if (c == '-')
		s = -1, c = getChar();
	while ('0' <= c && c <= '9')
		x = x * 10 + c - '0', c = getChar();
	return s == 1 ? x : -x;
}

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar(int x) {
	if (write_pos == buf_size)
		fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
	write_buf[write_pos++] = x;
}

template <class T>
inline void writeInt(T x, char end) {
	if (x < 0)
		writeChar('-'), x = -x;

	char s[24];
	int n = 0;
	while (x || !n)
		s[n++] = '0' + x % 10, x /= 10;
	while (n--)
		writeChar(s[n]);
	if (end)
		writeChar(end);
}

struct Flusher {
	~Flusher() {
		if (write_pos)
			fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
	}
} flusher;

vector<string> A;
vector<vector<int> > PL[26], PU[26];
vector<vector<int> > GRi[2], GCi[2];
vector<vector<char> > GRc[2], GCc[2];

int Qi[26], iQ;
char Qc[26];

int solve() {

	int n, m;
	n = readInt(), m = readInt();

	A.resize(n);

	for (int i = 0; i < 2; ++i) {
		GCi[i].resize(n);
		GRi[i].resize(n);
		GCc[i].resize(n);
		GRc[i].resize(n);
	}

	for (int i = 0; i < 26; i++) {
		PL[i].resize(n);
		PU[i].resize(n);
		for (int j = 0; j < n; j++) {
			PL[i][j].resize(m);
			PU[i][j].resize(m);
		}
	}

	for (int i1 = 0; i1 < 2; ++i1) {
		for (int i = 0; i < n; i++) {
			GRi[i1][i].resize(m);
			GCi[i1][i].resize(m);
			GRc[i1][i].resize(m);
			GCc[i1][i].resize(m);
		}
	}

	for (int i = 0; i < n; i++) {
		A[i].resize(m);
		for (int j = 0; j < m; ++j)
			A[i][j] = readChar();
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int t = 0; t < 26; t++) {
				if (j > 0) {
					if (A[i][j - 1] - 'a' == t)
						PL[t][i][j] = 1;// { 1, t, i, j - 1 };
					else {
						PL[t][i][j] = PL[t][i][j - 1] + 1;
					}
				} else {
					PL[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i > 0) {
					if (A[i - 1][j] - 'a' == t)
						PU[t][i][j] = 1;// { 1, t, i - 1, j };
					else
						PU[t][i][j] = PU[t][i - 1][j] + 1;
				} else {
					PU[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			iQ = 0;

			for (int t = 0; t < 26; t++) {
				Qi[iQ] = (-PL[t][i][j]);
				Qc[iQ++] = (t);
			}

			for (int kk = 0; kk < 2; ++kk) {
				GRi[kk][i][j] = (int)1e9;
				GRc[kk][i][j] = 0;
			}

			for (int k = 0; k < iQ; k++) {
				int cur = abs(Qi[k]);
				if (cur <= abs(GRi[0][i][j])) {
					GRi[1][i][j] = GRi[0][i][j];
					GRi[0][i][j] = Qi[k];
					GRc[1][i][j] = GRc[0][i][j];
					GRc[0][i][j] = Qc[k];
				} else if (cur <= abs(GRi[1][i][j])) {
					GRi[1][i][j] = Qi[k];
					GRc[1][i][j] = Qc[k];
				}
			}
		}
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			iQ = 0;

			for (int t = 0; t < 26; t++) {
				Qi[iQ] = (-PU[t][i][j]);
				Qc[iQ++] = (t);
			}

			for (int kk = 0; kk < 2; ++kk) {
				GCi[kk][i][j] = (int)1e9;
				GCc[kk][i][j] = 0;
			}

			for (int k = 0; k < iQ; k++) {
				int cur = abs(Qi[k]);
				if (cur <= abs(GCi[0][i][j])) {
					GCi[1][i][j] = GCi[0][i][j];
					GCi[0][i][j] = Qi[k];
					GCc[1][i][j] = GCc[0][i][j];
					GCc[0][i][j] = Qc[k];
				} else if (cur <= abs(GCi[1][i][j])) {
					GCi[1][i][j] = Qi[k];
					GCc[1][i][j] = Qc[k];
				}
			}
		}
	}

	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			for (int t = 0; t < 26; t++) {
				if (j + 1 < m) {
					if (A[i][j + 1] - 'a' == t) {
						PL[t][i][j] = 1;// { 1, t, i, j + 1 };
					} else {
						PL[t][i][j] = PL[t][i][j + 1] + 1;
					}
				} else {
					PL[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i + 1 < n) {
					if (A[i + 1][j] - 'a' == t) {
						PU[t][i][j] = 1;// { 1, t, i + 1, j };
					} else {
						PU[t][i][j] = PU[t][i + 1][j] + 1;
					}
				} else {
					PU[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			iQ = 0;

			for (int t = 0; t < 26; t++) {
				Qi[iQ] = (PL[t][i][j]);
				Qc[iQ++] = (t);
			}

			for (int k = 0; k < iQ; k++) {

				int okk = 0;
				for (int kk = 0; kk < 2; ++kk) {

					if (GRc[kk][i][j] == Qc[k] && abs(GRi[kk][i][j]) > abs(Qi[k])) {
						GRi[kk][i][j] = Qi[k];
						while (kk && abs(GRi[kk][i][j]) < abs(GRi[kk - 1][i][j])) {
							swap(GRi[kk][i][j], GRi[kk - 1][i][j]);
							swap(GRc[kk][i][j], GRc[kk - 1][i][j]);
							--kk;
						}

					}
					if (GRc[kk][i][j] == Qc[k]) {
						okk = 1;
						break;
					}
				}
				if (okk) continue;

				int cur = abs(Qi[k]);
				if (cur <= abs(GRi[0][i][j])) {
					GRi[1][i][j] = GRi[0][i][j];
					GRi[0][i][j] = Qi[k];
					GRc[1][i][j] = GRc[0][i][j];
					GRc[0][i][j] = Qc[k];
				} else if (cur <= abs(GRi[1][i][j])) {
					GRi[1][i][j] = Qi[k];
					GRc[1][i][j] = Qc[k];
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			iQ = 0;

			for (int t = 0; t < 26; t++) {
				Qi[iQ] = (PU[t][i][j]);
				Qc[iQ++] = (t);
			}

			for (int k = 0; k < iQ; k++) {

				int okk = 0;
				for (int kk = 0; kk < 2; ++kk) {

					if (GCc[kk][i][j] == Qc[k] && abs(GCi[kk][i][j]) > abs(Qi[k])) {
						GCi[kk][i][j] = Qi[k];

						while (kk && abs(GCi[kk][i][j]) < abs(GCi[kk - 1][i][j])) {
							swap(GCi[kk][i][j], GCi[kk - 1][i][j]);
							swap(GCc[kk][i][j], GCc[kk - 1][i][j]);
							--kk;
						}

					}
					if (GCc[kk][i][j] == Qc[k]) {
						okk = 1;
						break;
					}
				}
				if (okk) continue;

				int cur = abs(Qi[k]);
				if (cur <= abs(GCi[0][i][j])) {
					GCi[1][i][j] = GCi[0][i][j];
					GCi[0][i][j] = Qi[k];
					GCc[1][i][j] = GCc[0][i][j];
					GCc[0][i][j] = Qc[k];
				} else if (cur <= abs(GCi[1][i][j])) {
					GCi[1][i][j] = Qi[k];
					GCc[1][i][j] = Qc[k];
				}
			}
		}
	}

	int q;
	q = readInt();
	while (q--) {
		int i, j;
		i = readInt(), j = readInt();
		i--, j--;

		int c = A[i][j] - 'a';
		int ans = (int)1e9;
		int X, Y;

		for (int i1 = 0; i1 < 2; ++i1) {
			int c1i = GCi[i1][i][j];
			char c1c = GCc[i1][i][j];
			for (int i2 = 0; i2 < 2; ++i2) {
				int c2i = GRi[i2][i][j];
				char c2c = GRc[i2][i][j];
				if (c1c != c2c) {
					if (ans > abs(c1i) + abs(c2i)) {
						ans = abs(c1i) + abs(c2i);
						X = i + c1i;
						Y = j + c2i;
					}
				}
			}
		}
		if (ans == (int)1e9)
			writeInt(-1, '\n');
		else
			writeInt(X + 1, ' '), writeInt(j + 1, ' '), writeInt(i + 1, ' '), writeInt(Y + 1, '\n');
	}

	return 0;
}