#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <climits>
#include <cinttypes>

using namespace std;

typedef long long i64;
typedef pair < int, int > pii;
typedef pair < int, pii > piii;
#define mp(x, y) make_pair(x, y)
#define tri(x, a, b, c) x(a, x(b, c))
#define quad(x, a, b, c, d) x(x(a, b), x(c, d))
#define mendl '\n';
const int INF = 1e9;

int main() {

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector < vector < char > > board(n, vector < char >(m));
	vector < vector < int > > c_hor(n), c_vert(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> board[i][j];
			if (i && board[i - 1][j] != board[i][j]) {
				c_vert[j].push_back(i);
			}
			if (j && board[i][j - 1] != board[i][j]) {
				c_hor[i].push_back(j);
			}
		}
	}

	int k;
	cin >> k;

	int x, y;
	char u, d, l, r;
	vector < int >::iterator ru, rd, rl, rr;
	int riu, rid, ril, rir, minn;
	bool res;
	for (int tc = 0; tc < k; tc++) {
		cin >> x >> y;
		x--; y--;
		res = false;
		u = (x ? board[x - 1][y] : 0);
		d = (n - x - 1 ? board[x + 1][y] : 0);
		l = (y ? board[x][y - 1] : 0);
		r = (m - y - 1 ? board[x][y + 1] : 0);
		if (u && (r || l)) {
			if (r && u != r) {
				cout << x << " " << y + 1 << " " << x + 1 << " " << y + 2;
				res = true;
			}
			else {
				if (l && u != l) {
					cout << x << " " << y + 1 << " " << x + 1 << " " << y;
					res = true;
				}
			}
			if (res) {
				cout << mendl;
				continue;
			}
		}
		else {
			if (d && (r || l)) {
				if (r && d != r) {
					cout << x + 2 << " " << y + 1 << " " << x + 1 << " " << y + 2;
					res = true;
				}
				else {
					if (l && d != l) {
						cout << x + 2 << " " << y + 1 << " " << x + 1 << " " << y;
						res = true;
					}
				}
				if (res) {
					cout << mendl;
					continue;
				}
			}
		}

		rl = upper_bound(c_hor[x].begin(), c_hor[x].end(), y - 1);
		rr = upper_bound(c_hor[x].begin(), c_hor[x].end(), y + 1);
		ru = upper_bound(c_vert[y].begin(), c_vert[y].end(), x - 1);
		rd = upper_bound(c_vert[y].begin(), c_vert[y].end(), x + 1);

		if (rl != c_hor[x].begin()) {
			ril = y - *(rl - 1) + 1;
		}
		else
			ril = INF;

		if (rr != c_hor[x].end())
			rir = *rr - y;
		else
			rir = INF;
		if (ru != c_vert[y].begin())
			riu = x - *(ru - 1) + 1;
		else
			riu = INF;
		if (rd != c_vert[y].end())
			rid = *rd - x;
		else
			rid = INF;

		minn = quad(min, ril, rir, riu, rid);
		if (minn == INF) { 
			cout << -1 << mendl; 
			continue;
		}

		if (ril == minn) {
			cout << x + 1 << " " << y - minn + 1 << " " << (x ? x - 1 : x + 1) + 1 << " " << y + 1;
		}
		else {
			if (rir == minn) {
				cout << x + 1 << " " << y + minn + 1 << " " << (x ? x - 1 : x + 1) + 1 << " " << y + 1;
			}
			else {
				if (riu == minn) {
					cout << x - minn + 1 << " " << y + 1 << " " << x + 1 << " " << (y ? y - 1 : y + 1) + 1;
				}
				else{
					cout << x + minn + 1 << " " << y + 1 << " " << x + 1 << " " << (y ? y - 1 : y + 1) + 1;
				}
			}
		}
		cout << mendl;
	}

	return 0;
}
