import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Z {
    String fileName = "<name>";

    public class Pair implements Comparable<Pair> {
    	int x;
    	int t;
    	int i;
		public Pair(int x, int y, int i) {
			this.x = x;
			this.t = y;
			this.i = i;
		}
		@Override
		public int compareTo(Pair o) {
			if (this.x != o.x) {
				return this.x - o.x;
			}
			if (this.t != o.t) {
				return -(this.t - o.t);
			}
			return this.i - o.i;
		}
		@Override
		public String toString() {
			return "Pair [x=" + x + ", t=" + t + ", i=" + i + "]";
		}

		
		
    }
    
    public void solve() throws IOException {
    	int ALPH = 26;
    	int INF = Integer.MAX_VALUE;
    	int n = nextInt(), m = nextInt();
    	int[][] a = new int[n][m];
    	for (int i = 0; i < n; i++) {
			String s = nextToken();
			for (int j = 0; j < m; j++) {
				a[i][j] = (int) (s.charAt(j) - 'a');
			}
		}
    	
    	@SuppressWarnings("unchecked")
		TreeSet<Integer>[][] s = new TreeSet[n][ALPH];
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < ALPH; j++) {
				s[i][j] = new TreeSet<>();
			}
		}
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				s[i][a[i][j]].add(j);
			}
		}

    	@SuppressWarnings("unchecked")
		TreeSet<Integer>[][] c = new TreeSet[m][ALPH];
    	for (int i = 0; i < m; i++) {
			for (int j = 0; j < ALPH; j++) {
				c[i][j] = new TreeSet<>();
			}
		}
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				c[j][a[i][j]].add(i);
			}
		}
    	
    	int q = nextInt();
    	for (int i = 0; i < q; i++) {
			int x = nextInt() - 1, y = nextInt() - 1;
			int min = INF;
			int x1 = -1, y1 = -1;
			for (int iii = 0; iii < ALPH; iii++) {
				for (int jjj = 0; jjj < c.length; jjj++) {
					if (iii == jjj) {
						continue;
					}
					Integer l = s[x][iii].lower(y);
					Integer r = s[x][iii].higher(y);
					Integer u = c[y][jjj].lower(x);
					Integer d = c[y][jjj].higher(x);
					int ans = -1;
					if (u != null && r != null) {
						int res = Math.abs(y - r) + Math.abs(x - u);
						if (res < min) {
							min = res;
							y1 = r;
							x1 = u;
						}
					}
					if (d != null && r != null) {
						int res = Math.abs(y - r) + Math.abs(x - d);
						if (res < min) {
							min = res;
							y1 = r;
							x1 = d;
						}
					}
					if (d != null && l != null) {
						int res = Math.abs(y - l) + Math.abs(x - d);
						if (res < min) {
							min = res;
							y1 = l;
							x1 = d;
						}
					}
					if (u != null && l != null) {
						int res = Math.abs(y - l) + Math.abs(x - u);
						if (res < min) {
							min = res;
							y1 = l;
							x1 = u;
						}
					}
				}
			}
			if (x1 == -1) {
				System.out.println(-1);
			} else {
				System.out.println((x + 1) + " " + (y1 + 1) + " " + (x1 + 1) + " " + (y + 1));
			}
		}
    	
    	
    	
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

//            br = new BufferedReader(new FileReader(new File("input.txt"))); 
//            out = new PrintWriter(System.out);
            
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    @Override
	public String toString() {
		return "A [fileName=" + fileName + ", br=" + br + ", in=" + in + ", out=" + out + "]";
	}

	BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Z().run();
    }

}
