import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
 */

public class TaskD {
    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();

        char[][] arr = new char[n][m];

        for (int i = 0; i < n; i++) {
            String str = nextToken();

            for (int j = 0; j < m; j++) {
                arr[i][j] = str.charAt(j);
            }
        }

        int[][][] d1 = new int[26][n][m];
        int[][][] d2 = new int[26][m][n];

        int[] a = new int[26];

        for (int i = 0; i < n; i++) {
            Arrays.fill(a, Integer.MAX_VALUE / 2);

            for (int j = 0; j < m; j++) {
                for (int k = 0; k < 26; k++) {
                    if (a[k] == Integer.MAX_VALUE / 2) {
                        d1[k][i][j] = a[k];
                    } else {
                        d1[k][i][j] = (j - a[k]);
                    }
                }

                a[arr[i][j] - 'a'] = j;
            }

            Arrays.fill(a, Integer.MAX_VALUE / 2);

            for (int j = m - 1; j > -1; j--) {
                for (int k = 0; k < 26; k++) {
                    if (a[k] == Integer.MAX_VALUE / 2) {
                        d1[k][i][j] = Math.min(a[k], d1[k][i][j]);
                    } else {
                        d1[k][i][j] = Math.min(a[k] - j, d1[k][i][j]);
                    }
                }

                a[arr[i][j] - 'a'] = j;
            }
        }

        for (int j = 0; j < m; j++) {
            Arrays.fill(a, Integer.MAX_VALUE / 2);

            for (int i = 0; i < n; i++) {
                for (int k = 0; k < 26; k++) {
                    if (a[k] == Integer.MAX_VALUE / 2) {
                        d2[k][j][i] = a[k];
                    } else {
                        d2[k][j][i] = (i - a[k]);
                    }
                }

                a[arr[i][j] - 'a'] = i;
            }

            Arrays.fill(a, Integer.MAX_VALUE / 2);

            for (int i = n - 1; i > -1; i--) {
                for (int k = 0; k < 26; k++) {
                    if (a[k] == Integer.MAX_VALUE / 2) {
                        d2[k][j][i] = Math.min(a[k], d2[k][j][i]);
                    } else {
                        d2[k][j][i] = Math.min(a[k] - i, d2[k][j][i]);
                    }
                }

                a[arr[i][j] - 'a'] = i;
            }
        }

        int q = nextInt();
        StringBuilder builder = new StringBuilder();
        for (int req = 0; req < q; req++) {
            int i = nextInt() - 1;
            int j = nextInt() - 1;

            int r1 = -1;
            int c1 = -1;
            int r2 = -1;
            int c2 = -1;
            long best = Integer.MAX_VALUE;
            for (int col1 = 0; col1 < 26; col1++) {
                for (int col2 = 0; col2 < 26; col2++) {
                    if (col1 == col2) continue;

                    long cur =(long) d1[col1][i][j] + (long)d2[col2][j][i];
                    if (cur < best) {
                        best = cur;

                        int i1 = i + d2[col2][j][i];
                        int i2 = i - d2[col2][j][i];

                        int j1 = j + d1[col1][i][j];
                        int j2 = j - d1[col1][i][j];

                        if (0 <= i1 && i1 < n && arr[i1][j] == 'a' + col2) {
                            r1 = i1;
                            c1 = j;
                        } else if (0 <= i2 && i2 < n && arr[i2][j] == 'a' + col2) {
                            r1 = i2;
                            c1 = j;
                        } else {
//                            System.err.println("MAMKU IPAL");
                        }


                        if (0 <= j1 && j1 < m && arr[i][j1] == 'a' + col1) {
                            r2 = i;
                            c2 = j1;
                        } else if (0 <= j2 && j2 < m && arr[i][j2] == 'a' + col1) {
                            r2 = i;
                            c2 = j2;
                        } else {
//                            System.err.println("MAMKU IPAL");
                        }
                    }


                }
            }

            if (best < Integer.MAX_VALUE / 2) {
                builder.append(r1 + 1).append(' ').append(c1 + 1).append(' ').append(r2 + 1).append(' ').append(c2 + 1).append('\n');
            } else {
                builder.append("-1\n");
            }
        }
        out.println(builder);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskD().run();
    }
}
