#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct event {
  int time, id;
  bool enter;
  int exit;
};

bool operator<(const event& a, const event& b) {
    if (a.time != b.time) return a.time < b.time;
    if (a.enter != b.enter) return a.enter < b.enter;
    return a.id < b.id;
}

int main() {
  int n, m, k, a, b;
  cin >> n >> m >> k;
  int s = min(m, k + 1) - 1, t = s + 1;
  vector<event> feed;
  vector<int> pl(k, 0), busy(t, 0);
  for (int i = 0; i < k; i++) {
    cin >> a >> b;
    feed.push_back({a, i, true, b});
    feed.push_back({b, i, false, b});
  }
  sort(feed.begin(), feed.end());
  set<int> free0, free1;
  for (int i = 1; i <= t; i++) {
    if (i < t) free0.insert(i);
    free1.insert(-i);
  }
  for (auto& e: feed) {
    if (e.enter) {
        if (free0.size() > 0) {
            int place = *(free0.begin());
            free0.erase(free0.begin());
            pl[e.id] = place;
        } else if (free1.size() > 0) {
            int place = *(free1.begin());
            free1.erase(free1.begin());
            pl[e.id] = place;
            busy[t + place] += (e.exit - e.time);
        }
    } else {
        int place = pl[e.id];
        if (place == 0)
            continue;
        if (place < 0)
            free1.insert(place);
        else
            free0.insert(place);
    }
  }
  int minp = -1, mint = 1e9;
  for (int i = 0; i < t; i++) {
    if (busy[i] < mint) {
        mint = busy[i];
        minp = i + 1;
    }
  }
  cout << mint << ' ' << minp << endl;
  return 0;
}
