#include <iostream>
#include <vector>
#include <string>
#include <fstream>


using namespace std;

const int inf = 1e9;

void getans(vector<vector<int>> const& r,
                  vector<vector<int>> const& u,
                  vector<vector<int>> const& l,
                  vector<vector<int>> const& d,
                  vector<string> const& s,
                  int y, int x, int n, int m)
{ // x - stroka, y - stolbec
    vector<pair<int, int>> v;
    vector<pair<int, int>> h;
    //cerr << x << ' ' << y << endl;
    //cerr << "U " << ' ' << u[x][y] << endl;
    if (u[x][y] == inf)
    {
        if (x > 0)
        {
            v.push_back({x - 1, y});
        }
    }
    else
    {
        if (u[x][y] > 1)
        {
            v.push_back({x - 1, y});
            v.push_back({x - u[x][y], y});
        }
        else
        {
            //cerr << "KEK " << x - 1 << ' ' << y << ' ' << u[x - 1][y] << endl;
            v.push_back({x - 1, y});
            if (u[x - 1][y] != inf)
            {
                v.push_back({x - 1 - u[x - 1][y], y});
            }
        }
    }
    //cerr << "D " << ' ' << d[x][y] << endl;
    if (d[x][y] == inf)
    {
        //cerr << x << ' ' << n - 1 << endl;
        if (x < n - 1)
        {
            v.push_back({x + 1, y});
        }
    }
    else
    {
        if (d[x][y] > 1)
        {
            v.push_back({x + 1, y});
            v.push_back({x + d[x][y], y});
        }
        else
        {
            v.push_back({x + 1, y});
            if (d[x + 1][y] != inf)
            {
                v.push_back({x + 1 + d[x + 1][y], y});
            }
        }
    }
    //cerr << "L " << ' ' << l[x][y] << endl;
    if (l[x][y] == inf)
    {
        //cerr <<"PL " << x << ' ' << y << endl;
        if (y > 0)
        {
            h.push_back({x, y - 1});
        }
    }
    else
    {
        if (l[x][y] > 1)
        {
            h.push_back({x, y - 1});
            h.push_back({x, y - l[x][y]});
        }
        else
        {
            h.push_back({x, y - 1});
            if (l[x][y - 1] != inf)
            {
                h.push_back({x, y - 1 - l[x][y - 1]});
            }
        }
    }
    //cerr << "R " << ' ' << r[x][y] << endl;
    if (r[x][y] == inf)
    {
        if (y < m - 1)
        {
            h.push_back({x, y + 1});
        }
    }
    else
    {
        //cerr << "R" << ' ' << r[x][y] << endl;
        if (r[x][y] > 1)
        {
            h.push_back({x, y + 1});
            h.push_back({x, y + r[x][y]});
        }
        else
        {
            h.push_back({x, y + 1});
            if (r[x][y + 1] != inf)
            {
                h.push_back({x, y + 1 + r[x][y + 1]});
            }
        }
    }
    int ans = inf;
    int x1, x2, y1, y2;
    //cerr << v.size() << ' ' << h.size() << endl;
    for (auto vp : v)
    {
        for (auto hp : h)
        {
            //cerr << vp.first << ' ' << vp.second << ' ' << hp.first << ' ' << hp.second << endl;
            if (s[vp.first][vp.second] != s[hp.first][hp.second] &&
                abs(vp.first - hp.first) + abs(vp.second - hp.second) < ans)
            {
                ans = abs(vp.first - hp.first) + abs(vp.second - hp.second);
                x1 = vp.first;
                x2 = hp.first;
                y1 = vp.second;
                y2 = hp.second;
            }
        }
    }
    //cout << endl;
    if (ans == inf)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << x1 + 1 << ' ' << y1 + 1 << ' ' << x2 + 1 << ' ' << y2 + 1 << endl;
    }
}


int main(){
    ifstream cin("input.txt");
    int n, m;
    cin >> n >> m;
    vector <string> field(n);
    for (int i = 0; i < n; i++){
        cin >> field[i];
    }
    vector <vector <int> > upalp(n, vector <int> (m, inf));
    vector <vector <int> > leftalp(n, vector <int> (m, inf));
    vector <vector <int> > downalp(n, vector <int> (m, inf));
    vector <vector <int> > rightalp(n, vector <int> (m, inf));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            if (i != 0){
                if (field[i][j] != field[i - 1][j]){
                    upalp[i][j] = 1;
                }
                else {
                    upalp[i][j] = min(upalp[i - 1][j] + 1, inf);
                }
            }
            if (j != 0){
                if (field[i][j] != field[i][j - 1]){
                    leftalp[i][j] = 1;
                }
                else{
                    leftalp[i][j] = min(leftalp[i][j - 1] + 1, inf);
                }
            }
        }
    }
    for (int i = n - 1; i >= 0; i--){
        for (int j = m - 1; j >= 0; j--){
            if (i != n - 1){
                if (field[i][j] != field[i + 1][j]){
                    downalp[i][j] = 1;
                }
                else {
                    downalp[i][j] = min(downalp[i + 1][j] + 1, inf);
                }
            }
            if (j != m - 1){
                if (field[i][j] != field[i][j + 1]){
                    rightalp[i][j] = 1;
                }
                else{
                    rightalp[i][j] = min(rightalp[i][j + 1] + 1, inf);
                }
            }
        }
    }
    /*
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cout << upalp[i][j] << " ";
        }
        cout << endl;
    }
    cout << "UP" << endl << endl;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cout << leftalp[i][j] << " ";
        }
        cout << endl;
    }
    cout << "LEFT" << endl << endl;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cout << downalp[i][j] << " ";
        }
        cout << endl;
    }
    cout << "DOWN" << endl << endl;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cout << rightalp[i][j] << " ";
        }
        cout << endl;
    }
    cout << "RIGHT" << endl << endl;
    */
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int x, y;
        cin >> y >> x;//y - stroka, x - stolbec;
        x -= 1;
        y -= 1;
        getans(rightalp, upalp, leftalp, downalp, field, x, y, n, m);
    }
}
