#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int CH = 3;

struct Node {
	int dst, val, x, y;

	inline bool friend operator <(Node a, Node b) {
		return a.dst < b.dst || (a.dst == b.dst && a.val < b.val);
	}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;

	vector<string> f(n);

	for (int i = 0; i < n; i++) {
		cin >> f[i];
	}

	vector<vector<set<Node> > > col(n, vector<set<Node> >(m)), row(n, vector<set<Node> >(m));

	for (int i = 0; i < n; i++) {
		vector<int> near(26, -INF);
		set<pair<int, int> > tmp;
		for (int j = 0; j < m; j++) {
			

			for (auto c : tmp) {
				if ((int)row[i][j].size() == CH) break;
				// if (c.second == f[i][j] - 'a') continue;
				row[i][j].insert({ j + c.first, c.second, i, -c.first });
			}

			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = max(near[f[i][j] - 'a'], j);
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
		}

		near.assign(26, INF);
		tmp.clear();

		for (int j = m - 1; j >= 0; j--) {
			vector<int> tt(26, INF);

			for (auto c : row[i][j]) {
				tt[c.val] = c.dst;
            }

			for (auto c : tmp) {
				// if (c.second == f[i][j] - 'a') continue;
				if (tt[c.second] != INF && tt[c.second] > c.first - j) {
					row[i][j].erase({ tt[c.second], c.second, 0, 0 });
				}
				else if (tt[c.second] != INF) {
					continue;
				}
				if ((int)row[i][j].size() == CH && j - (*(--row[i][j].end())).y < c.first - j) break;

				if (row[i][j].size() > CH) tt[(*(--row[i][j].end())).val] = INF;
				tt[c.second] = c.first - j;
				row[i][j].insert({ c.first - j, c.second, i, c.first });
				if (row[i][j].size() > CH) row.erase(--row.end());
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = min(near[f[i][j] - 'a'], j);
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });
		}
	}

	for (int j = 0; j < m; j++) {
		vector<int> near(26, -INF);
		set<pair<int, int> > tmp;
		for (int i = 0; i < n; i++) {
			
			for (auto c : tmp) {
				if ((int)col[i][j].size() == CH) break;
				//if (c.second == f[i][j] - 'a') continue;
				col[i][j].insert({ i + c.first, c.second, -c.first, j });
			}
			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = max(near[f[i][j] - 'a'], i);
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });

		}

		near.assign(26, INF);
		tmp.clear();

		for (int i = n - 1; i >= 0; i--) {
			vector<int> tt(26, INF);

			for (auto c : col[i][j]) {
				tt[c.val] = c.dst;
			}
			
			for (auto c : tmp) {
				if (tt[c.second] != INF && tt[c.second] > c.first - i) {
					col[i][j].erase({ tt[c.second], c.second, 0, 0 });
				}
				else if (tt[c.second] != INF) {
					continue;
				}
				// if (c.second == f[i][j] - 'a') continue;
				if ((int)col[i][j].size() == CH && i - (*(--col[i][j].end())).y < c.first - i) break;

				if ((int)col[i][j].size() > CH) tt[(*(--col[i][j].end())).val] = INF;
				tt[c.second] = c.first - i;
                col[i][j].insert({ c.first - i, c.second, c.first, j });
                if ((int)col[i][j].size() > CH) col[i][j].erase(--col[i][j].end());
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = min(near[f[i][j] - 'a'], i);
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });

		}
	}

	int q;
	cin >> q;

	while (q--) {
		int x, y;
		cin >> x >> y;
		x--, y--;

		int mn = INF, x1, x2, y1, y2;

		for (auto t1 : row[x][y]) {
			for (auto t2 : col[x][y]) {
				if (abs(t1.x - t2.x) + abs(t1.y - t2.y) < mn && t1.val != t2.val) {
					mn = abs(t1.x - t2.x) + abs(t1.y - t2.y);
					x1 = t1.x;
					x2 = t2.x;
					y1 = t1.y;
					y2 = t2.y;
				}
			}
		}

		if (mn == INF) {
			cout << "-1\n";
		}
		else {
			cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << "\n";
		}
	}

	return 0;
}

