#include <iostream>
#include <algorithm>
#include <chrono>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define pr pair<int, int>
#define x first
#define y second

struct GW {
	int in, out;
	int seat;
	GW(int i, int o, int s) : in(i), out(o), seat(s) {}
};

map<int, vector<GW> > go_away;
set<int> free_places;
int over_soul[3 * 100000] = {0};

int n, m, k;

int main() {

	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	vector<pair<int, int>> mas;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int in, out;
		cin >> in >> out;
		mas.push_back({ in, out });
	}
	for (int i = 1; i < m; i++) {
		free_places.insert(i);
		free_places.insert(i + m);
	}
	free_places.insert(m);

	stable_sort(mas.begin(), mas.end(), [] (pr a, pr b) { return a.x < b.x;  });
	
	for (int i = 0; i < mas.size(); i++) {
		int cur_in, cur_out;
		cur_in = mas[i].first;
		cur_out = mas[i].second;

		while (!go_away.empty() && go_away.begin()->first <= cur_in) {
			vector<GW> &proc = go_away.begin()->second;
			for (int j = 0; j < proc.size(); j++) {
				GW &cur_gw = proc[j];
				if (cur_gw.seat < m) {
					free_places.insert(cur_gw.seat);
				}
				else {
					free_places.insert(cur_gw.seat);
					over_soul[cur_gw.seat - m] += cur_gw.out - cur_gw.in;
				}
			}
			go_away.erase(go_away.begin());
		}
		if (free_places.empty())
			continue;
		int seat = *free_places.begin();
		free_places.erase(free_places.begin());
		go_away[cur_out].push_back(GW(cur_in,cur_out, seat));
	}

	while (!go_away.empty()) {
		vector<GW> &proc = go_away.begin()->second;
		for (int j = 0; j < proc.size(); j++) {
			GW &cur_gw = proc[j];
			//cout << cur_gw.seat << ' ' << cur_gw.in << ' ' << cur_gw.out << endl;
			if (cur_gw.seat < m) {
				free_places.insert(cur_gw.seat);
			}
			else {
				free_places.insert(cur_gw.seat);
				over_soul[cur_gw.seat - m] += cur_gw.out - cur_gw.in;
			}
		}
		go_away.erase(go_away.begin());
	}

	int min_place = 0;
	for (int i = 0; i < m; i++) {
		if (over_soul[i] < over_soul[min_place])
			min_place = i;
	}
	cout << over_soul[min_place] << ' ' << min_place + 1;

}