#include <iostream>
#include <algorithm>
#include <chrono>
#include <map>
#include <set>
#include <vector>

using namespace std;

int bin_search(vector<pair<int, char>> &arr, int i) {
	int l = 0;
	int r = arr.size();
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (arr[m].first <= i)
			l = m;
		else
			r = m;
	}
	return l;
}

int main() {

	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<vector<char>> mas(n, vector<char>(m, 0));
	vector<vector<pair<int, char>>> rows(n), cols(m);


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> mas[i][j];
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (rows[i].empty() || rows[i].back().second != mas[i][j])
				rows[i].push_back({ j, mas[i][j] });
		}
	}

	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (cols[j].empty() || cols[j].back().second != mas[i][j])
				cols[j].push_back({ i, mas[i][j] });
		}
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		int cur_x = bin_search(cols[y], x);
		int cur_y = bin_search(rows[x], y);
		int lx = max(cur_x - 2, 0);
		int rx = min(cur_x + 2, (int)cols[y].size() - 1);

		int ly = max(cur_y - 2, 0);
		int ry = min(cur_y + 2, (int)rows[x].size() - 1);

		int min_dist = 1e9;
		pair<int, int> col_ans, row_ans;

		for (int cx = lx; cx <= rx; cx++) {
			for (int cy = ly; cy <= ry; cy++) {
				int x_size;
				if (cx == cols[y].size() - 1)
					x_size = n - cols[y][cx].first;
				else
					x_size = cols[y][cx + 1].first - cols[y][cx].first;
				int y_size;
				if (cy == rows[x].size() - 1)
					y_size = m - rows[x][cy].first;
				else
					y_size = rows[x][cy + 1].first - rows[x][cy].first;
				if ((cx == cur_x && x_size == 1) || (cy == cur_y && y_size == 1))
					continue;

				int dist_col;
				int col_coor;
				if (cx < cur_x) {
					col_coor = cols[y][cx + 1].first - 1;
					dist_col = abs(col_coor - x);
				}
				else if (cx == cur_x) {
					if ((x >= 1 && mas[x - 1][y] == mas[x][y]))
							col_coor = x - 1;
						else
							col_coor = x + 1;
					dist_col = 1;
				}
				else {
					col_coor = cols[y][cx].first;
					dist_col = abs(col_coor - x);
				}

				int dist_row;
				int row_coor;
				if (cy < cur_y) {
					row_coor = rows[x][cy + 1].first - 1;
					dist_row = abs(row_coor - y);
				}
				else if (cy == cur_y) {
						if ((y >= 1 && mas[x][y - 1] == mas[x][y]))
							row_coor =y-1 ;
						else
							row_coor = y + 1;
						dist_row = 1;
				}
				else {
					row_coor = rows[x][cy].first;
					dist_row = abs(row_coor - y);
				}

				
				int dist = dist_col + dist_row;
				if (rows[x][cy].second != cols[y][cx].second && dist < min_dist) {
					min_dist = dist;
					col_ans = { col_coor, y };
					row_ans = { x, row_coor };
				}
			}
		}
		if (min_dist == 1e9) {
			cout << -1 << endl;
		}
		else {
			cout << col_ans.first + 1 << ' ' << col_ans.second + 1 << ' ' << row_ans.first + 1 << ' ' << row_ans.second + 1 << endl;
		}
	}

}